##################################
### SubChan.tcl                ###
### Version 2.0                ###
### By Wcc and MatriX-         ###
### wcc@techmonkeys.org        ###
### matrix@miracle1.net        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2003 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

#############################################################################
## This script forces users to be on your main channel before joining your ##
## sub-channel.                                                            ##
#############################################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

######################################
# Set your main channel's name here. #
######################################

set subchan_setting(main) "#Channel1"

#####################################
# Set your sub-channel's name here. #
#####################################

set subchan_setting(sub) "#Channel2"

#####################################################################
# Set your kick reason here.                                        #
# %mainchan is your main channel, and %subchan is your sub channel. #
#####################################################################

set subchan_setting(reason) "You were banned from %subchan because you were not on %mainchan. You must be on %mainchan to be in %subchan. Please join %mainchan and the ban will be removed."

#####################################################################
# Set your unban notice here (set to "" to disable).                #
# %mainchan is your main channel, and %subchan is your sub channel. #
#####################################################################

set subchan_setting(notice) "You are now unbanned from %subchan. In the future, please join %mainchan before joining %subchan. NOTE: If you part this channel while still on %subchan, the ban will be reinstated."

#############################
# Set the ban type here:    #
# 1 - *!*@host.domain	    #
# 2 - *!user@host.domain    #
# 3 - nick!*@host.domain    #
# 4 - nick!user@host.domain #
# 5 - *!?user@*.host.domain #
#############################

set subchan_setting(bantype) "1"

###################################
# Enable use of bold in DCC chat? #
###################################

set subchan_setting(bold) 1

#########################################
# Prefix "SPLIT:" in DCC chat messages? #
#########################################

set subchan_setting(SUBCHAN:) 1

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002SUBCHAN:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002SUBCHAN:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

bind join - "$subchan_setting(sub) *" subchan_checkjoin
bind join - "$subchan_setting(main) *" subchan_checkjoin
bind part - "$subchan_setting(main) *" subchan_checkpart

proc subchan_ncm {pattern string} { return [string match [string tolower $pattern] [string tolower $string]] }
proc subchan_dopre {} {
	global subchan_setting
	if {!$subchan_setting(SUBCHAN:)} { return "" }
	if {!$subchan_setting(bold)} { return "SUBCHAN: " }
	return "\002SUBCHAN:\002 "
}
proc subchan_maskban {nick uhost} {
	global subchan_setting
	switch -- $subchan_setting(bantype) {
		1 { set ban "*!*@[lindex [split $uhost @] 1]" }
		2 { set ban "*!$uhost" }
		3 { set ban "$nick!*@[lindex [split $uhost @] 1]" }
		4 { set ban "$nick!$uhost" }
		5 { set ban [maskhost $uhost] }
		default { set ban "*!*@[lindex [split $uhost @] 1]" }
	}
	return $ban
}
proc subchan_checkjoin {nick uhost hand chan} {
	global subchan_setting
	if {![botisop $subchan_setting(sub)]} { return }
	set banmask [subchan_maskban $nick $uhost]
	if {[subchan_ncm $chan $subchan_setting(main)]} {
		if {![ischanban $banmask $subchan_setting(sub)]} { return }
		regsub -all -- "%mainchan" $subchan_setting(notice) $subchan_setting(main) msg
		regsub -all -- "%subchan" $msg $subchan_setting(sub) msg
		pushmode $subchan_setting(sub) -b $banmask
		if {$msg != ""} { puthelp "NOTICE $nick :$msg" }
		return
	}
	if {[onchan $nick $subchan_setting(main)] || [matchattr $hand ov|ov $subchan_setting(main)] || [matchattr $hand ov|ov $subchan_setting(sub)] || [isvoice $nick $subchan_setting(main)] || [isop $nick $subchan_setting(main)]} { return }
	regsub -all -- "%mainchan" $subchan_setting(reason) $subchan_setting(main) msg
	regsub -all -- "%subchan" $msg $subchan_setting(sub) msg
	pushmode $subchan_setting(sub) +b $banmask
	putserv "KICK $subchan_setting(sub) $nick :$msg"
}
proc subchan_checkpart {nick uhost hand chan text} {
	global subchan_setting
	set banmask [subchan_maskban $nick $uhost]
	if {![botisop $subchan_setting(sub)] || ![onchan $nick $subchan_setting(sub)] || [matchattr $hand vo|vo $subchan_setting(main)] || [matchattr $hand vo|vo $subchan_setting(sub)] || [isvoice $nick $subchan_setting(sub)] || [isop $nick $subchan_setting(sub)]} { return }
	regsub -all -- "%mainchan" $subchan_setting(reason) $subchan_setting(main) msg
	regsub -all -- "%subchan" $msg $subchan_setting(sub) msg
	pushmode $subchan_setting(sub) +b $banmask
	putserv "KICK $subchan_setting(sub) $nick :$msg"
}
putlog "\002SUBCHAN:\002 SubChan.tcl 2.0 by Wcc and MatriX- is loaded."